## libsdsl 2.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(AppendCompilerFlags)

## Project information ##
project(sdsl CXX C)
set(PROJECT_VENDOR "Simon Gog")
set(PROJECT_CONTACT "simon.gog@gmail.com")
set(PROJECT_URL "https://github.com/simongog/sdsl-lite")
set(PROJECT_DESCRIPTION "SDSL: Succinct Data Structure Library")
set(CMAKE_BUILD_TYPE "Release")

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" PROJECT_VERSION_FULL)
string(REGEX REPLACE "[\n\r]" "" PROJECT_VERSION_FULL "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+$" "\\1" PROJECT_VERSION_MAJOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+)\\.[0-9]+$" "\\1" PROJECT_VERSION_MINOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+)$" "\\1" PROJECT_VERSION_PATCH "${PROJECT_VERSION_FULL}")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
math(EXPR LIBRARY_VERSION_MAJOR "1 + ${PROJECT_VERSION_MAJOR}")
set(LIBRARY_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(LIBRARY_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(LIBRARY_VERSION_FULL "${LIBRARY_VERSION}.${LIBRARY_VERSION_PATCH}")


option(CODE_COVERAGE "Set ON to add code coverage compile options" OFF)

# C++11 compiler Check
if(NOT CMAKE_CXX_COMPILER_VERSION) # work around for cmake versions smaller than 2.8.10
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE CMAKE_CXX_COMPILER_VERSION)
endif()
if(CMAKE_CXX_COMPILER MATCHES ".*clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      set(CMAKE_COMPILER_IS_CLANGXX 1)
endif()
if( (CMAKE_COMPILER_IS_GNUCXX AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.7) OR
    (CMAKE_COMPILER_IS_CLANGXX AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 3.2))
  message(FATAL_ERROR "Your C++ compiler does not support C++11. Please install g++ 4.7 (or greater) or clang 3.2 (or greater)")
else()
  message(STATUS "Compiler is recent enough to support C++11.")
endif()

if( CMAKE_COMPILER_IS_GNUCXX )
    append_cxx_compiler_flags("-std=c++11 -Wall -Wextra  -DNDEBUG" "GCC" CMAKE_CXX_FLAGS)
    append_cxx_compiler_flags("-O3 -ffast-math -funroll-loops" "GCC" CMAKE_CXX_OPT_FLAGS)
    if ( CODE_COVERAGE )
        append_cxx_compiler_flags("-g -fprofile-arcs -ftest-coverage -lgcov" "GCC" CMAKE_CXX_FLAGS)
    endif()
else()
    append_cxx_compiler_flags("-std=c++11 -DNDEBUG" "CLANG" CMAKE_CXX_FLAGS)
    append_cxx_compiler_flags("-stdlib=libc++" "CLANG" CMAKE_CXX_FLAGS)
    append_cxx_compiler_flags("-O3 -ffast-math -funroll-loops" "CLANG" CMAKE_CXX_OPT_FLAGS)
endif()


include(CheckSSE4_2)
if( BUILTIN_POPCNT )
    if( CMAKE_COMPILER_IS_GNUCXX )
        append_cxx_compiler_flags("-msse4.2" "GCC" CMAKE_CXX_OPT_FLAGS)
    else()
        append_cxx_compiler_flags("-msse4.2" "CLANG" CMAKE_CXX_OPT_FLAGS)
    endif()
endif()

add_subdirectory(external)
add_subdirectory(include)
add_subdirectory(lib)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Make.helper.cmake"
		       "${CMAKE_CURRENT_SOURCE_DIR}/Make.helper" @ONLY)

## Add 'uninstall' target ##
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake")

=== examples/Makefile ===
include ../Make.helper
CXX_FLAGS=$(MY_CXX_FLAGS) $(MY_CXX_OPT_FLAGS) -I$(INC_DIR) -L$(LIB_DIR) 
CCLIB=-lsdsl -ldivsufsort -ldivsufsort64 
SOURCES=$(wildcard *.cpp)
EXECS=$(SOURCES:.cpp=.x)

all: $(EXECS)

build-test: $(EXECS)
	        
%.x:%.cpp 
	$(MY_CXX) $(CXX_FLAGS) -o $@ $< $(CCLIB) 

clean:
	rm -f $(EXECS)
	rm -rf *.dSYM

=== external/CMakeLists.txt ===

add_subdirectory(gtest-1.6.0)
add_subdirectory(libdivsufsort-2.0.1)

=== lib/CMakeLists.txt ===
include_directories(#"${CMAKE_CURRENT_SOURCE_DIR}/../include"
					"${CMAKE_CURRENT_BINARY_DIR}/../include" 
					"${CMAKE_CURRENT_BINARY_DIR}/../external/libdivsufsort-2.0.1/include" 
					)


file(GLOB libFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}  "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp") # select all .cpp-files

set( sdsl_SRCS ${libFiles} )

add_library( sdsl ${sdsl_SRCS} )

install(TARGETS sdsl
		RUNTIME DESTINATION bin
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib)	

set_target_properties(sdsl PROPERTIES
	VERSION "${LIBRARY_VERSION_FULL}"	
	SOVERSION "${LIBRARY_VERSION_MAJOR}"	
#	DEFINE_SYMBOL SDSL_BUILD_DLL
#	RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/../examples"
	)

=== test/Makefile ===
include ../Make.helper
CXX_FLAGS=$(MY_CXX_FLAGS) -Wall -Werror -Wunused-parameter -g -O3 \
		  -I$(INC_DIR) \
		  -I../build/external/gtest-1.6.0/include \
		  -L$(LIB_DIR) \
		  -L../build/external/gtest-1.6.0
LIB_SDSL=$(LIB_DIR)/libsdsl.a
CCLIB=-lsdsl -ldivsufsort -ldivsufsort64 -lgtest
TMP_DIR=tmp
SOURCES=$(wildcard *Test.cpp)
EXECS=$(SOURCES:.cpp=.x)
EXEC_LIST=$(patsubst %,./%;,$(EXECS))                # list of executables

GCDAs=$(SOURCES:.cpp=.gcda)
GCNOs=$(SOURCES:.cpp=.gcno)

BIT_VECTOR_TC_PATH:=$(call config_column,BitVectorTest.config,2)
BIT_VECTOR_TESTS:=$(patsubst %,bit-vector-test/%,$(BIT_VECTOR_TC_PATH))

RANK_SUPPORT_TESTS:=$(patsubst %,rank-support-test/%,$(BIT_VECTOR_TC_PATH))

SELECT_SUPPORT_TESTS:=$(patsubst %,select-support-test/%,$(BIT_VECTOR_TC_PATH))

WT_BYTE_TC_PATHS:=$(call config_column,WtByteTest.config,2)
WT_BYTE_TESTS:=$(patsubst %,wt-byte-test/%,$(WT_BYTE_TC_PATHS))

WT_INT_TC_PATHS:=$(call config_column,WtIntTest.config,2)
WT_INT_TESTS:=$(patsubst %,wt-int-test/%,$(WT_INT_TC_PATHS))

CSA_BYTE_TC_PATHS:=$(call config_column,CsaByteTest.config,2)
CSA_BYTE_TESTS:=$(patsubst %,csa-byte-test/%,$(CSA_BYTE_TC_PATHS))

CSA_INT_TC_PATHS:=$(call config_column,CsaIntTest.config,2)
CSA_INT_TESTS:=$(patsubst %,csa-int-test/%,$(CSA_INT_TC_PATHS))

CST_BYTE_TC_PATHS:=$(call config_column,CstByteTest.config,2)
CST_BYTE_TESTS:=$(patsubst %,cst-byte-test/%,$(CST_BYTE_TC_PATHS))

CST_INT_TC_PATHS:=$(call config_column,CstIntTest.config,2)
CST_INT_TESTS:=$(patsubst %,cst-int-test/%,$(CST_INT_TC_PATHS))

RMQ_TC_PATHS:=$(call config_column,RMQTest.config,2)
RMQ_TESTS:=$(patsubst %,rmq-test/%,$(RMQ_TC_PATHS))

LCP_CONSTRUCT_PATHS:=$(call config_column,LcpConstructTest.config,2)
LCP_CONSTRUCT_TESTS:=$(patsubst %,lcp-construct-test/%,$(LCP_CONSTRUCT_PATHS))

SA_CONSTRUCT_PATHS:=$(call config_column,SaConstructTest.config,2)
SA_CONSTRUCT_TESTS:=$(patsubst %,sa-construct-test/%,$(SA_CONSTRUCT_PATHS))

SEARCH_BIDIRECTIONAL_PATHS:=$(call config_column,SearchBidirectionalTest.config,2)
SEARCH_BIDIRECTIONAL_TESTS:=$(patsubst %,search-bidirectional-test/%,$(SEARCH_BIDIRECTIONAL_PATHS))

K2TREAP_TC_PATH:=$(call config_column,K2TreapTest.config,1)
K2TREAP_TESTS:=$(patsubst %,k2treap-test/%,$(K2TREAP_TC_PATH))

TC_PATHS:= $(WT_BYTE_TC_PATHS) $(WT_INT_TC_PATHS) \
		   $(CSA_BYTE_TC_PATHS) $(CSA_INT_TC_PATHS) \
		   $(CST_BYTE_TC_PATHS) $(CST_INT_TC_PATHS)



# do not delete the generated/downloaded test_cases
.SECONDARY: $(TC_PATHS)

test:	bits-test \
	coder-test \
	int-vector-test \
	inv-perm-support-test \
	int-vector-mapper-test \
	int-vector-buffer-test \
	bit-vector-test \
	rank-support-test\
	select-support-test\
	wt-byte-test \
	wt-int-test \
	csa-byte-test \
	csa-int-test \
	cst-byte-test \
	cst-int-test \
	rmq-test \
	sa-construct-test \
	search-bidirectional-test \
	sorted-int-stack-test \
	nn-dict-dynamic-test \
	k2treap-test

build-test: $(EXECS)
	cd ../tutorial; make build-test
	cd ../examples; make build-test
	cd ../benchmark/indexing_count; make
	cd ../benchmark/indexing_locate; make
	cd ../benchmark/indexing_extract; make
	cd ../benchmark/rrr_vector; make
	cd ../benchmark/document_retrieval; make
	cd ../benchmark/wavelet_trees; make

build-test-clean: clean
	cd ../tutorial; make clean
	cd ../examples; make clean
	cd ../benchmark/indexing_count; make clean-build
	cd ../benchmark/indexing_locate; make clean-build
	cd ../benchmark/indexing_extract; make clean-build
	cd ../benchmark/rrr_vector; make clean-build
	cd ../benchmark/document_retrieval; make clean-build
	cd ../benchmark/wavelet_trees; make clean-build

generators: BitVectorGenerator.x IntVectorGenerator.x ReplaceIntVectorValue.x

bits-test: ./BitsTest.x
	@$(PREFIX) ./BitsTest.x

coder-test: ./CoderTest.x
	@$(PREFIX) ./CoderTest.x

int-vector-test: ./IntVectorTest.x
	@$(PREFIX) ./IntVectorTest.x

inv-perm-support-test: ./InvPermSupportTest.x
	@$(PREFIX) ./InvPermSupportTest.x

int-vector-buffer-test: ./IntVectorBufferTest.x
	@$(PREFIX) ./IntVectorBufferTest.x

int-vector-mapper-test: ./IntVectorMapperTest.x
	@$(PREFIX) ./IntVectorMapperTest.x

sorted-int-stack-test: ./SortedIntStackTest.x
	@$(PREFIX) ./SortedIntStackTest.x

nn-dict-dynamic-test: ./NNDictDynamicTest.x
	@$(PREFIX) ./NNDictDynamicTest.x


bit-vector-test: generators $(BIT_VECTOR_TESTS)

rank-support-test: generators $(RANK_SUPPORT_TESTS)

select-support-test: generators $(SELECT_SUPPORT_TESTS)

wt-byte-test: generators $(WT_BYTE_TESTS)

wt-int-test: generators $(WT_INT_TESTS)

csa-byte-test: generators $(CSA_BYTE_TESTS)

csa-int-test: generators $(CSA_INT_TESTS)

cst-byte-test: generators $(CST_BYTE_TESTS)

cst-int-test: generators $(CST_INT_TESTS)

rmq-test: generators $(RMQ_TESTS)

lcp-construct-test: generators $(LCP_CONSTRUCT_TESTS)

sa-construct-test: generators $(SA_CONSTRUCT_TESTS)

search-bidirectional-test: generators $(SEARCH_BIDIRECTIONAL_TESTS)

k2treap-test: ./K2TreapTest.x generators $(K2TREAP_TESTS)

bit-vector-test/test_cases/%: ./BitVectorTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$*"
	@$(PREFIX) ./BitVectorTest.x test_cases/$*

rank-support-test/test_cases/%: ./RankSupportTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$*"
	@$(PREFIX) ./RankSupportTest.x test_cases/$*

select-support-test/test_cases/%: ./SelectSupportTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$*"
	@$(PREFIX) ./SelectSupportTest.x test_cases/$*

wt-byte-test/test_cases/%: ./WtByteTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$* semi-external"
	@$(PREFIX) ./WtByteTest.x test_cases/$* $(TMP_DIR)/wt-byte.tmp
	@echo "TEST_CASE: test_cases/$* in-memory"
	@$(PREFIX) ./WtByteTest.x test_cases/$* $(TMP_DIR)/wt-byte.tmp in-memory

wt-int-test/test_cases/%: ./WtIntTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$* semi-external"
	@$(PREFIX) ./WtIntTest.x test_cases/$* $(TMP_DIR)/wt-int.tmp
	@echo "TEST_CASE: test_cases/$* in-memory"
	@$(PREFIX) ./WtIntTest.x test_cases/$* $(TMP_DIR)/wt-int.tmp in-memory

csa-byte-test/test_cases/%: ./CsaByteTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$* semi-external"
	@$(PREFIX) ./CsaByteTest.x test_cases/$* $(TMP_DIR)/csa-byte.tmp $(TMP_DIR)
	@echo "TEST_CASE: test_cases/$* in-memory"
	@$(PREFIX) ./CsaByteTest.x test_cases/$* $(TMP_DIR)/csa-byte.tmp $(TMP_DIR) in-memory

csa-int-test/test_cases/%: ./CsaIntTest.x test_cases/%
	$(eval NUM_BYTES:=$(call config_filter,CsaIntTest.config,test_cases/$*,4))
	@echo "TEST_CASE: test_cases/$* NUM_BYTES=$(NUM_BYTES) semi-external"
	@$(PREFIX) ./CsaIntTest.x test_cases/$* $(NUM_BYTES) $(TMP_DIR)/csa-int.tmp $(TMP_DIR)
	@echo "TEST_CASE: test_cases/$* NUM_BYTES=$(NUM_BYTES) in-memory"
	@$(PREFIX) ./CsaIntTest.x test_cases/$* $(NUM_BYTES) $(TMP_DIR)/csa-int.tmp $(TMP_DIR) in-memory

cst-byte-test/test_cases/%: ./CstByteTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$* semi-external"
	$(PREFIX) ./CstByteTest.x test_cases/$* $(TMP_DIR)/cst-byte.tmp $(TMP_DIR)
	@echo "TEST_CASE: test_cases/$* in-memory"
	$(PREFIX) ./CstByteTest.x test_cases/$* $(TMP_DIR)/cst-byte.tmp $(TMP_DIR) in-memory

cst-int-test/test_cases/%: ./CstIntTest.x test_cases/%
	$(eval NUM_BYTES:=$(call config_filter,CstIntTest.config,test_cases/$*,4))
	@echo "TEST_CASE: test_cases/$* NUM_BYTES=$(NUM_BYTES) semi-external"
	@$(PREFIX) ./CstIntTest.x test_cases/$* $(NUM_BYTES) $(TMP_DIR)/cst-int.tmp $(TMP_DIR)
	@echo "TEST_CASE: test_cases/$* NUM_BYTES=$(NUM_BYTES) in-memory"
	@$(PREFIX) ./CstIntTest.x test_cases/$* $(NUM_BYTES) $(TMP_DIR)/cst-int.tmp $(TMP_DIR) in-memory

rmq-test/test_cases/%: ./RMQTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$*"
	@$(PREFIX) ./RMQTest.x test_cases/$* $(TMP_DIR)/rmq.tmp

lcp-construct-test/test_cases/%: ./LcpConstructTest.x test_cases/%
	$(eval TC_ID:=$(call config_filter,LcpConstructTest.config,test_cases/$*,1))
	@echo "TEST_CASE: test_cases/$*; TC_ID=$(TC_ID)"
	@$(PREFIX) ./LcpConstructTest.x test_cases/$* $(TMP_DIR) $(TC_ID)

sa-construct-test/test_cases/%: ./SaConstructTest.x test_cases/%
	$(eval TC_ID:=$(call config_filter,SaConstructTest.config,test_cases/$*,1))
	@echo "TEST_CASE: test_cases/$*; TC_ID=$(TC_ID)"
	@$(PREFIX) ./SaConstructTest.x test_cases/$* $(TMP_DIR) $(TC_ID)

search-bidirectional-test/test_cases/%: ./SearchBidirectionalTest.x test_cases/%
	@echo "TEST_CASE: test_cases/$*"
	@$(PREFIX) ./SearchBidirectionalTest.x test_cases/$*

k2treap-test/%: ./K2TreapTest.x  
	$(eval X:=$(call config_select,K2TreapTest.config,$*,2))
	$(eval Y:=$(call config_select,K2TreapTest.config,$*,3))
	$(eval W:=$(call config_select,K2TreapTest.config,$*,4))
	make $(X) $(Y) $(W)
	@echo "X=$X, Y=$Y, W=$W"
	mv $(X) test_cases/K2T.$*.x	
	mv $(Y) test_cases/K2T.$*.y
	mv $(W) test_cases/K2T.$*.w
	@echo "TEST_CASE: $* semi-external"
	$(PREFIX) ./K2TreapTest.x test_cases/K2T.$* $(TMP_DIR)/K2T.$*
	@echo "TEST_CASE: test_cases/$* in-memory"
	$(PREFIX) ./K2TreapTest.x test_cases/K2T.$* $(TMP_DIR)/K2T.$* in-memory

# Format: test_cases/int-vec.[LEN].[WIDTH].[DEFAULT].[SEED]
test_cases/int-vec.%: IntVectorGenerator.x
	@echo "Generate input test_cases/int-vec.$*"
	$(eval LEN:=$(call dim,1,$*))
	$(eval WIDTH:=$(call dim,2,$*))
	$(eval DEFAULT:=$(call dim,3,$*))
	$(eval SEED:=$(call dim,4,$*))
	@./IntVectorGenerator.x $@ $(LEN) $(WIDTH) $(DEFAULT) $(SEED)

# Format: test_cases/int-vec-sa.[LEN].[WIDTH].[DEFAULT].[SEED]
test_cases/int-vec-sa.%: IntVectorGenerator.x
	@echo "Generate input test_cases/int-vec-sa.$*"
	$(eval LEN:=$(call dim,1,$*))
	$(eval WIDTH:=$(call dim,2,$*))
	$(eval DEFAULT:=$(call dim,3,$*))
	$(eval SEED:=$(call dim,4,$*))
	@./IntVectorGenerator.x $@ $(LEN) $(WIDTH) $(DEFAULT) $(SEED)
	@./ReplaceIntVectorValue.x $@ 0 1

# Format: test_cases/int-vec-k2t.[LEN].[WIDTH].[DEFAULT].[SEED].[x|y|w]
test_cases/int-vec-k2t.%: IntVectorGenerator.x
	@echo "Generate input test_cases/int-vec-k2t.$*"
	$(eval LEN:=$(call dim,1,$*))
	$(eval WIDTH:=$(call dim,2,$*))
	$(eval DEFAULT:=$(call dim,3,$*))
	$(eval SEED:=$(call dim,4,$*))
	@./IntVectorGenerator.x $@ $(LEN) $(WIDTH) $(DEFAULT) $(SEED)

test_cases/bit-vec.%: BitVectorGenerator.x
	@echo "Generate input test_cases/bit-vec.$*"
	@./BitVectorGenerator.x $@ $*

%.x:%.cpp $(LIB_SDSL)
	$(MY_CXX) $(CXX_FLAGS) -o $@ $< $(CCLIB)

test_cases/%:
	$(eval URL:=$(call config_filter,download.config,$@,2))
	@$(if $(URL),,\
		$(error "No download link specified for test case $@") )
	@echo "Download input from $(URL) using curl"
	$(eval DEST_DIR:=$(shell dirname $@))
	cd $(DEST_DIR); curl -O $(URL)
	$(eval FILE:=$(DEST_DIR)/$(notdir $(URL)))
	@$(if $(filter-out ".gz",$(FILE)),\
		echo "Extract file $(FILE) using gunzip";\
		gunzip $(FILE))


clean:
	rm -f $(EXECS) $(GCDAs) $(GCNOs)
	rm -f tmp/*
	rm -rf *.dSYM

cleanall: clean
	rm -f $(TC_PATHS)

=== tutorial/Makefile ===
include ../Make.helper
CXX_FLAGS=$(MY_CXX_FLAGS) $(MY_CXX_OPT_FLAGS) -I$(INC_DIR) -L$(LIB_DIR) 
CCLIB=-lsdsl -ldivsufsort -ldivsufsort64 
SOURCES=$(wildcard *.cpp)
EXECS=$(SOURCES:.cpp=.x)

all: $(EXECS)

build-test: $(EXECS)
	        
%.x:%.cpp
	$(MY_CXX) $(CXX_FLAGS) -o $@ $< $(CCLIB) 

clean:
	rm -f $(EXECS)
	rm -rf *.dSYM

=== benchmark/rrr_vector/Makefile ===
include ../Make.helper
CXX_FLAGS = $(MY_CXX_FLAGS) # in compile_options.config
LIBS = -lsdsl 
SRC_DIR = src
TMP_DIR = ../tmp
# Sampling rate for rrr_vector
t=32
# Block sizes
TC_PATHS:=$(call config_column,test_case.config,2)
TC_IDS:=$(call config_ids,test_case.config)
COMPILE_IDS:=$(call config_ids,compile_options.config)
KS:=$(call config_ids,block_size.config)

all: execs 

input: bin/generate_rnd_bitvector $(TC_PATHS)

RRR_EXECS = $(foreach K,$(KS),\
			  $(foreach COMPILE_ID,$(COMPILE_IDS),bin/rrr_time_and_space_$(K).$(COMPILE_ID)))

RES_FILES = $(foreach TC_ID,$(TC_IDS),\
              $(foreach K,$(KS),\
				$(foreach COMPILE_ID,$(COMPILE_IDS),\
					results/$(TC_ID).$(K).$(COMPILE_ID))))
						
RES_FILE=results/all.txt

# Target for the generator programs for the random bitvectors of different densities
bin/generate_rnd_bitvector: ${SRC_DIR}/generate_rnd_bitvector.cpp
	$(MY_CXX) -O3 $(CXX_FLAGS) $(SRC_DIR)/generate_rnd_bitvector.cpp -L$(LIB_DIR) -I$(INC_DIR) -o $@ $(LIBS)

# Targets for the access/rank/select rrr_vector experiment
# Format: bin/rrr_time_and_space_[R].[COMPILE_ID]
bin/rrr_time_and_space_%: $(SRC_DIR)/rrr_time_and_space.cpp 
	$(eval K:=$(call dim,1,$*)) 
	$(eval COMPILE_ID:=$(call dim,2,$*)) 
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(CXX_FLAGS) $(COMPILE_OPTIONS) -DBLOCK_SIZE=$(K) -L$(LIB_DIR) \
		  $(SRC_DIR)/rrr_time_and_space.cpp -I$(INC_DIR) -o $@ $(LIBS)

execs: $(RRR_EXECS) 


timing: input execs $(RES_FILES) 
	cat $(RES_FILES) > $(RES_FILE)
	@cd visualize; make	

# Format: results/[TC_ID].[K].[COMPILE_ID]
results/%: 
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval K:=$(call dim,2,$*)) 
	$(eval COMPILE_ID:=$(call dim,3,$*)) 
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	@echo "Running bin/rrr_time_and_space_$(K).$(COMPILE_ID) on $(TC_ID)"
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# K = $(K)" >> $@
	@echo "# COMPILE_ID = $(COMPILE_ID)" >> $@
	@bin/rrr_time_and_space_$(K).$(COMPILE_ID) $(TC_PATH) $(t) >> $@

# Target for generating a random bitvector of size SIZE and density DENSITY
# Format: data/rnd_[DENSITY].[SIZE]
../data/rnd_%: bin/generate_rnd_bitvector
	$(eval DENSITY:=$(call dim,1,$*)) 
	$(eval SIZE:=$(call dim,2,$*)) 
	@echo "Generating bitvector of density $(DENSITY) and size $(SIZE)"
	@bin/generate_rnd_bitvector $(SIZE) $(DENSITY) $@

include ../Make.download

clean-build:
	@echo "Remove executables"
	rm -f $(RRR_EXECS)

clean:
	rm -f $(RRR_EXECS) bin/generate_rnd_bitvector   

clean_results: 
	rm -f $(RES_FILES) 
		

cleanall: clean clean_results

=== external/gtest-1.6.0/CMakeLists.txt ===
########################################################################
# CMake build script for Google Test.
#
# To run the tests for Google Test itself on Linux, use 'make test' or
# ctest.  You can select which tests to run using 'ctest -R regex'.
# For more options, run 'ctest --help'.

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to
# make it prominent in the GUI.
option(BUILD_SHARED_LIBS "Build shared libraries (DLLs)." OFF)

# When other libraries are using a shared version of runtime libraries,
# Google Test also has to use one.
option(
  gtest_force_shared_crt
  "Use shared (DLL) run-time lib even when Google Test is built as static lib."
  OFF)

option(gtest_build_tests "Build all of gtest's own tests." OFF)

option(gtest_build_samples "Build gtest's sample programs." OFF)

option(gtest_disable_pthreads "Disable uses of pthreads in gtest." ON)

# Defines pre_project_set_up_hermetic_build() and set_up_hermetic_build().
include(cmake/hermetic_build.cmake OPTIONAL)

if (COMMAND pre_project_set_up_hermetic_build)
  pre_project_set_up_hermetic_build()
endif()

########################################################################
#
# Project-wide settings

# Name of the project.
#
# CMake files in this project can refer to the root source directory
# as ${gtest_SOURCE_DIR} and to the root binary directory as
# ${gtest_BINARY_DIR}.
# Language "C" is required for find_package(Threads).
project(gtest CXX C)
cmake_minimum_required(VERSION 2.6.2)

if (COMMAND set_up_hermetic_build)
  set_up_hermetic_build()
endif()

# Define helper functions and macros used by Google Test.
include(cmake/internal_utils.cmake)

config_compiler_and_linker()  # Defined in internal_utils.cmake.

# Where Google Test's .h files can be found.
include_directories(
  ${gtest_SOURCE_DIR}/include
  ${gtest_SOURCE_DIR})

# Where Google Test's libraries can be found.
link_directories(${gtest_BINARY_DIR}/src)

########################################################################
#
# Defines the gtest & gtest_main libraries.  User tests should link
# with one of them.

# Google Test libraries.  We build them using more strict warnings than what
# are used for other targets, to ensure that gtest can be compiled by a user
# aggressive about warnings.
cxx_library(gtest "${cxx_strict}" src/gtest-all.cc)
cxx_library(gtest_main "${cxx_strict}" src/gtest_main.cc)
target_link_libraries(gtest_main gtest)

add_subdirectory(include)

#install(TARGETS gtest LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
#install(TARGETS gtest_main LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)

########################################################################
#
# Samples on how to link user tests with gtest or gtest_main.
#
# They are not built by default.  To build them, set the
# gtest_build_samples option to ON.  You can do it by running ccmake
# or specifying the -Dgtest_build_samples=ON flag when running cmake.

if (gtest_build_samples)
  cxx_executable(sample1_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample2_unittest samples gtest_main samples/sample2.cc)
  cxx_executable(sample3_unittest samples gtest_main)
  cxx_executable(sample4_unittest samples gtest_main samples/sample4.cc)
  cxx_executable(sample5_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample6_unittest samples gtest_main)
  cxx_executable(sample7_unittest samples gtest_main)
  cxx_executable(sample8_unittest samples gtest_main)
  cxx_executable(sample9_unittest samples gtest)
  cxx_executable(sample10_unittest samples gtest)
endif()

########################################################################
#
# Google Test's own tests.
#
# You can skip this section if you aren't interested in testing
# Google Test itself.
#
# The tests are not built by default.  To build them, set the
# gtest_build_tests option to ON.  You can do it by running ccmake
# or specifying the -Dgtest_build_tests=ON flag when running cmake.

if (gtest_build_tests)
  # This must be set in the root directory for the tests to be run by
  # 'make test' or ctest.
  enable_testing()

  ############################################################
  # C++ tests built with standard compiler flags.

  cxx_test(gtest-death-test_test gtest_main)
  cxx_test(gtest_environment_test gtest)
  cxx_test(gtest-filepath_test gtest_main)
  cxx_test(gtest-linked_ptr_test gtest_main)
  cxx_test(gtest-listener_test gtest_main)
  cxx_test(gtest_main_unittest gtest_main)
  cxx_test(gtest-message_test gtest_main)
  cxx_test(gtest_no_test_unittest gtest)
  cxx_test(gtest-options_test gtest_main)
  cxx_test(gtest-param-test_test gtest
    test/gtest-param-test2_test.cc)
  cxx_test(gtest-port_test gtest_main)
  cxx_test(gtest_pred_impl_unittest gtest_main)
  cxx_test(gtest-printers_test gtest_main)
  cxx_test(gtest_prod_test gtest_main
    test/production.cc)
  cxx_test(gtest_repeat_test gtest)
  cxx_test(gtest_sole_header_test gtest_main)
  cxx_test(gtest_stress_test gtest)
  cxx_test(gtest-test-part_test gtest_main)
  cxx_test(gtest_throw_on_failure_ex_test gtest)
  cxx_test(gtest-typed-test_test gtest_main
    test/gtest-typed-test2_test.cc)
  cxx_test(gtest_unittest gtest_main)
  cxx_test(gtest-unittest-api_test gtest)

  ############################################################
  # C++ tests built with non-standard compiler flags.

  # MSVC 7.1 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)
    cxx_library(gtest_no_exception "${cxx_no_exception}"
      src/gtest-all.cc)
    cxx_library(gtest_main_no_exception "${cxx_no_exception}"
      src/gtest-all.cc src/gtest_main.cc)
  endif()
  cxx_library(gtest_main_no_rtti "${cxx_no_rtti}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_test_with_flags(gtest-death-test_ex_nocatch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=0"
    gtest test/gtest-death-test_ex_test.cc)
  cxx_test_with_flags(gtest-death-test_ex_catch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=1"
    gtest test/gtest-death-test_ex_test.cc)

  cxx_test_with_flags(gtest_no_rtti_unittest "${cxx_no_rtti}"
    gtest_main_no_rtti test/gtest_unittest.cc)

  cxx_shared_library(gtest_dll "${cxx_default}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_executable_with_flags(gtest_dll_test_ "${cxx_default}"
    gtest_dll test/gtest_all_test.cc)
  set_target_properties(gtest_dll_test_
                        PROPERTIES
                        COMPILE_DEFINITIONS "GTEST_LINKED_AS_SHARED_LIBRARY=1")

  if (NOT MSVC OR NOT MSVC_VERSION EQUAL 1600)
    # The C++ Standard specifies tuple_element<int, class>.
    # Yet MSVC 10's <utility> declares tuple_element<size_t, class>.
    # That declaration conflicts with our own standard-conforming
    # tuple implementation.  Therefore using our own tuple with
    # MSVC 10 doesn't compile.
    cxx_library(gtest_main_use_own_tuple "${cxx_use_own_tuple}"
      src/gtest-all.cc src/gtest_main.cc)

    cxx_test_with_flags(gtest-tuple_test "${cxx_use_own_tuple}"
      gtest_main_use_own_tuple test/gtest-tuple_test.cc)

    cxx_test_with_flags(gtest_use_own_tuple_test "${cxx_use_own_tuple}"
      gtest_main_use_own_tuple
      test/gtest-param-test_test.cc test/gtest-param-test2_test.cc)
  endif()

  ############################################################
  # Python tests.

  cxx_executable(gtest_break_on_failure_unittest_ test gtest)
  py_test(gtest_break_on_failure_unittest)

  # MSVC 7.1 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)
    cxx_executable_with_flags(
      gtest_catch_exceptions_no_ex_test_
      "${cxx_no_exception}"
      gtest_main_no_exception
      test/gtest_catch_exceptions_test_.cc)
  endif()

  cxx_executable_with_flags(
    gtest_catch_exceptions_ex_test_
    "${cxx_exception}"
    gtest_main
    test/gtest_catch_exceptions_test_.cc)
  py_test(gtest_catch_exceptions_test)

  cxx_executable(gtest_color_test_ test gtest)
  py_test(gtest_color_test)

  cxx_executable(gtest_env_var_test_ test gtest)
  py_test(gtest_env_var_test)

  cxx_executable(gtest_filter_unittest_ test gtest)
  py_test(gtest_filter_unittest)

  cxx_executable(gtest_help_test_ test gtest_main)
  py_test(gtest_help_test)

  cxx_executable(gtest_list_tests_unittest_ test gtest)
  py_test(gtest_list_tests_unittest)

  cxx_executable(gtest_output_test_ test gtest)
  py_test(gtest_output_test)

  cxx_executable(gtest_shuffle_test_ test gtest)
  py_test(gtest_shuffle_test)

  # MSVC 7.1 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)
    cxx_executable(gtest_throw_on_failure_test_ test gtest_no_exception)
    set_target_properties(gtest_throw_on_failure_test_
      PROPERTIES
      COMPILE_FLAGS "${cxx_no_exception}")
    py_test(gtest_throw_on_failure_test)
  endif()

  cxx_executable(gtest_uninitialized_test_ test gtest)
  py_test(gtest_uninitialized_test)

  cxx_executable(gtest_xml_outfile1_test_ test gtest_main)
  cxx_executable(gtest_xml_outfile2_test_ test gtest_main)
  py_test(gtest_xml_outfiles_test)

  cxx_executable(gtest_xml_output_unittest_ test gtest)
  py_test(gtest_xml_output_unittest)
endif()

=== external/libdivsufsort-2.0.1/CMakeLists.txt ===
### cmake file for building libdivsufsort Package ###
cmake_minimum_required(VERSION 2.4)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(AppendCompilerFlags)

## SVN revision ##
set(SVN_REVISION "")
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")
  execute_process(COMMAND svn info --xml
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    OUTPUT_VARIABLE SVN_INFO ERROR_QUIET)
  if(SVN_INFO)
    string(REGEX MATCH "<entry[^>]+" SVN_REVISION "${SVN_INFO}")
    string(REGEX REPLACE "^.*revision=\"([0-9]+)\".*$" "\\1" SVN_REVISION "${SVN_REVISION}")
  endif(SVN_INFO)
endif(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")

## Project information ##
project(libdivsufsort C)
set(PROJECT_VENDOR "Yuta Mori")
set(PROJECT_CONTACT "yuta.256@gmail.com")
set(PROJECT_URL "http://libdivsufsort.googlecode.com/")
set(PROJECT_DESCRIPTION "A lightweight suffix sorting library")
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" PROJECT_VERSION_FULL)
string(REGEX REPLACE "[\n\r]" "" PROJECT_VERSION_FULL "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+$" "\\1" PROJECT_VERSION_MAJOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+)\\.[0-9]+$" "\\1" PROJECT_VERSION_MINOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+)$" "\\1" PROJECT_VERSION_PATCH "${PROJECT_VERSION_FULL}")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
math(EXPR LIBRARY_VERSION_MAJOR "1 + ${PROJECT_VERSION_MAJOR}")
set(LIBRARY_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(LIBRARY_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(LIBRARY_VERSION_FULL "${LIBRARY_VERSION}.${LIBRARY_VERSION_PATCH}")
if(SVN_REVISION)
  set(PROJECT_VERSION_FULL "svn-r${SVN_REVISION}")
endif(SVN_REVISION)

## CPack configuration ##
set(CPACK_GENERATOR "TGZ;TBZ2;ZIP")
set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2;ZIP")
include(ProjectCPack)

## Project options ##
option(BUILD_SHARED_LIBS "Set to OFF to build static libraries" OFF)
option(BUILD_EXAMPLES "Build examples" OFF)
option(BUILD_DIVSUFSORT64 "Build libdivsufsort64" ON)
option(USE_OPENMP "Use OpenMP for parallelization" OFF)
option(WITH_LFS "Enable Large File Support" ON)

## Build type ##
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
elseif(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(CMAKE_VERBOSE_MAKEFILE ON)
endif(NOT CMAKE_BUILD_TYPE)

## Compiler options ##
if(MSVC)
  append_c_compiler_flags("/W4" "VC" CMAKE_C_FLAGS)
  append_c_compiler_flags("/Oi;/Ot;/Ox;/Oy" "VC" CMAKE_C_FLAGS_RELEASE)
  if(USE_OPENMP)
    append_c_compiler_flags("/openmp" "VC" CMAKE_C_FLAGS)
  endif(USE_OPENMP)
elseif(BORLAND)
  append_c_compiler_flags("-w" "BCC" CMAKE_C_FLAGS)
  append_c_compiler_flags("-Oi;-Og;-Os;-Ov;-Ox" "BCC" CMAKE_C_FLAGS_RELEASE)
else(MSVC)
  if(CMAKE_COMPILER_IS_GNUCC)
    append_c_compiler_flags("-Wall" "GCC" CMAKE_C_FLAGS)
    append_c_compiler_flags("-fomit-frame-pointer" "GCC" CMAKE_C_FLAGS_RELEASE)
    if(USE_OPENMP)
      append_c_compiler_flags("-fopenmp" "GCC" CMAKE_C_FLAGS)
    endif(USE_OPENMP)
  else(CMAKE_COMPILER_IS_GNUCC)
    append_c_compiler_flags("-Wall" "UNKNOWN" CMAKE_C_FLAGS)
    append_c_compiler_flags("-fomit-frame-pointer" "UNKNOWN" CMAKE_C_FLAGS_RELEASE)
    if(USE_OPENMP)
      append_c_compiler_flags("-fopenmp;-openmp;-omp" "UNKNOWN" CMAKE_C_FLAGS)
    endif(USE_OPENMP)
  endif(CMAKE_COMPILER_IS_GNUCC)
endif(MSVC)

## Add definitions ##
add_definitions(-DHAVE_CONFIG_H=1 -D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS)

## Add subdirectories ##
#add_subdirectory(pkgconfig)
add_subdirectory(include)
add_subdirectory(lib)
if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif(BUILD_EXAMPLES)

=== tutorial/document_listing/Makefile ===
include ../../Make.helper
CXX_FLAGS=$(MY_CXX_FLAGS) $(MY_CXX_OPT_FLAGS) -I$(INC_DIR) -L$(LIB_DIR) 
CCLIB=-lsdsl -ldivsufsort -ldivsufsort64 
EXECS=doc_list_index_sada.x

all: $(EXECS)

build-test: $(EXECS)

doc_list_index_sada.x: doc_list_index.cpp doc_list_index_sada.hpp
	$(MY_CXX) \
		$(CXX_FLAGS)\
		-DIDX_TYPE="doc_list_index_sada<>" \
		-DIDX_SUF=".sada-idx" \
	-o $@ $< $(CCLIB) 

clean:
	rm -f $(EXECS)
	rm -rf *.dSYM

=== external/gtest-1.6.0/include/CMakeLists.txt ===

add_subdirectory(gtest)

=== external/libdivsufsort-2.0.1/examples/CMakeLists.txt ===
## Add definitions ##
add_definitions(-D_LARGEFILE_SOURCE -D_LARGE_FILES -D_FILE_OFFSET_BITS=64)

## Targets ##
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../include"
                    "${CMAKE_CURRENT_BINARY_DIR}/../include")
link_directories("${CMAKE_CURRENT_BINARY_DIR}/../lib")
foreach(src suftest mksary sasearch bwt unbwt)
  add_executable(${src} ${src}.c)
  target_link_libraries(${src} divsufsort)
endforeach(src)

=== debian/changelog ===
libsdsl (2.0.3-4) unstable; urgency=medium

  * debian/clean: Enable building twice in a row
  * cme fix dpkg-control
  * Vcs-fields now pointing to Debian Science repository
  * Add myself to uploaders

 -- Andreas Tille <tille@debian.org>  Tue, 12 Apr 2016 18:26:06 +0200

libsdsl (2.0.3-3) unstable; urgency=medium

  * d/control: add missing architectures (thanks Adam Borowski!)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 10 Apr 2016 19:38:42 +0200

libsdsl (2.0.3-2) unstable; urgency=medium

  * Upload to unstable
  * d/control: move to Debian Science team
  * d/control: bump Standard Version to 3.9.7 (no changes needed)
  * d/control: restrict to four supported architectures

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 10 Apr 2016 17:25:31 +0200

libsdsl (2.0.3-1) experimental; urgency=low

  * Initial release (Closes: #796962)

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 04 Aug 2015 20:28:45 +0200

=== debian/control ===
Source: libsdsl
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tomasz Buchert <tomasz@debian.org>,
           Andreas Tille <tille@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libdivsufsort-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/libsdsl.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/libsdsl.git
Homepage: https://github.com/simongog/sdsl-lite

Package: libsdsl-dev
Architecture: alpha amd64 arm64 kfreebsd-amd64 mips64el ppc64 ppc64el s390x sparc64 x32
Multi-Arch: same
Section: libdevel
Depends: libdivsufsort-dev,
         libsdsl3 (= ${binary:Version}),
         ${misc:Depends}
Description: succinct data structure library - development files
 The Succinct Data Structure Library (SDSL) is a powerful and flexible
 C++11 library implementing succinct data structures. In total, the
 library contains the highlights of 40 research publications. Succinct
 data structures can represent an object (such as a bitvector or a
 tree) in space close the information-theoretic lower bound of the
 object while supporting operations of the original object
 efficiently. The theoretical time complexity of an operations
 performed on the classical data structure and the equivalent succinct
 data structure are (most of the time) identical.
 .
 This package installs development files.

Package: libsdsl3
Architecture: alpha amd64 arm64 kfreebsd-amd64 mips64el ppc64 ppc64el s390x sparc64 x32
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: succinct data structure library
 The Succinct Data Structure Library (SDSL) is a powerful and flexible
 C++11 library implementing succinct data structures. In total, the
 library contains the highlights of 40 research publications. Succinct
 data structures can represent an object (such as a bitvector or a
 tree) in space close the information-theoretic lower bound of the
 object while supporting operations of the original object
 efficiently. The theoretical time complexity of an operations
 performed on the classical data structure and the equivalent succinct
 data structure are (most of the time) identical.
 .
 This package installs static library.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@ --parallel

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON
